<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The selected strategy determines how the phosphorus and potassium recommendations are computed.</translate>
          </q-banner>

          <q-card-section v-if="pkStrategyOptions && pkStrategyOptions.length">
            <q-list>
              <q-item
                v-for="pkStrategy in pkStrategyOptions"
                :key="pkStrategy.name"
                tag="label"
                v-ripple
                class="q-px-none"
              >
                <q-item-section
                  avatar
                  top
                >
                  <q-radio
                    v-model="storePKStrategy"
                    :val="pkStrategy.name"
                  />
                </q-item-section>
                <q-item-section>
                  <q-item-label>{{ pkStrategy.label }}</q-item-label>
                  <q-item-label caption>
                    {{ pkStrategy.description }}
                  </q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import queryNavigatorF3Config from 'src/pages/fieldbook/fertilization/algorithms/navigator-f3/graphql/queryNavigatorF3Config'
import queryNavigatorF3PKStrategyEnum from 'src/pages/fieldbook/fertilization/algorithms/navigator-f3/graphql/queryNavigatorF3PKStrategyEnum'

export default {
  name: 'NavigatorF3IrrigationPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins],
  data () {
    return {
      navigatorF3Config: null,
      navigatorF3PKStrategies: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Fertilization strategy')
    },
    pageSubTitle () {
      return 'Navigator F3'
    },
    canContinue () {
      return this.isParameterSet(this.storePKStrategy)
    },
    loading () {
      return !this.navigatorF3Config || !this.navigatorF3PKStrategies
    },
    pkStrategyOptions () {
      if (!this.navigatorF3PKStrategies) {
        return []
      } else {
        const pkStrategyNames = this.navigatorF3PKStrategies.map(strategy => strategy.name)
        const strategies = [{
          name: 'sufficiency',
          label: this.$gettext('Sufficiency'),
          description: this.$gettext('Apply P or K only when the soil test level is below the defined threshold value for fertilizer response for the specific test used to assess the nutrient availability in soil.')
        }, {
          name: 'minimum_fertilizer',
          label: this.$gettext('Buildup and maintenance (minimum fertilizer)'),
          description: this.$gettext('Add fertilizer to compensate for P and K exported from the farm and also to progressively rise the level to the threshold values, if the current level is below the threshold.')
        }, {
          name: 'maximum_yield',
          label: this.$gettext('Buildup and maintenance (maximum yield)'),
          description: this.$gettext('Similar to the previous strategy but now using the parameters leading to maximum yield.')
        }, {
          name: 'maintenance',
          label: this.$gettext('Maintenance'),
          description: this.$gettext('If no soil tests are available, this alternative consisting of adding fertilizers to compensate for the P and K exported by harvested parts of crops. Here we assume that the user considers that P and K levels in the soil are not limiting for crop yields, the approach being a “zero balance”.')
        }]
        return strategies.filter(strategy => pkStrategyNames.includes(strategy.name))
      }
    },
    storePKStrategy: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.pkStrategy?.name
      },
      set (v) {
        const pkStrategy = this.navigatorF3PKStrategies?.find(val => val.name === v)
        this.updateParameter('pkStrategy', pkStrategy)
      }
    }
  },
  async mounted () {
    // Load data from cache (or online if not in cache)
    await this.loadData('cache-first')

    // Set default values from the config
    if (!this.isParameterSet(this.storePKStrategy)) {
      this.storePKStrategy = this.navigatorF3Config?.default_phosphorus_potassium_strategy
    }

    // Refresh online data (do not wait until completion)
    this.loadData('network-only')
  },
  methods: {
    onClickNext () {
      this.$router.push({
        name: 'navigatorF3Soil'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'navigatorF3HarvestAndResidues'
      })
    },
    async loadConfig (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryNavigatorF3Config,
        fetchPolicy
      })
      this.navigatorF3Config = data?.navigator_f3__config
    },
    async loadPKStrategies (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryNavigatorF3PKStrategyEnum,
        fetchPolicy
      })
      this.navigatorF3PKStrategies = data?.__type.enumValues
    },
    loadData (fetchPolicy) {
      return Promise.all([
        this.loadConfig(fetchPolicy),
        this.loadPKStrategies(fetchPolicy)
      ])
    }
  }
}
</script>
